Merge pull request #373 from QuickJack/master
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         array-init.cs           \
48         arraylist.cs            \
49         assemblyresolve_event.cs        \
50         assemblyresolve_event3.cs       \
51         checked.cs              \
52         char-isnumber.cs        \
53         create-instance.cs      \
54         field-layout.cs         \
55         pack-layout.cs          \
56         pack-bug.cs             \
57         hash-table.cs           \
58         test-ops.cs             \
59         obj.cs                  \
60         test-dup-mp.cs          \
61         string.cs               \
62         stringbuilder.cs        \
63         switch.cs               \
64         outparm.cs              \
65         delegate.cs             \
66         bitconverter.cs         \
67         exception.cs            \
68         exception2.cs           \
69         exception3.cs           \
70         exception4.cs           \
71         exception5.cs           \
72         exception6.cs           \
73         exception7.cs           \
74         exception8.cs           \
75         exception10.cs          \
76         exception11.cs          \
77         exception12.cs          \
78         exception13.cs          \
79         exception14.cs          \
80         exception15.cs          \
81         exception16.cs          \
82         exception17.cs          \
83         typeload-unaligned.cs   \
84         struct.cs               \
85         valuetype-gettype.cs    \
86         typeof-ptr.cs           \
87         static-constructor.cs   \
88         pinvoke.cs              \
89         pinvoke2.cs             \
90         pinvoke3.cs             \
91         pinvoke11.cs            \
92         pinvoke13.cs            \
93         pinvoke17.cs            \
94         invoke.cs               \
95         invoke2.cs              \
96         runtime-invoke.cs               \
97         invoke-string-ctors.cs          \
98         reinit.cs               \
99         box.cs                  \
100         array.cs                \
101         enum.cs                 \
102         enum2.cs                \
103         property.cs             \
104         enumcast.cs             \
105         assignable-tests.cs     \
106         array-cast.cs           \
107         array-subtype-attr.cs   \
108         cattr-compile.cs        \
109         cattr-field.cs          \
110         cattr-object.cs         \
111         custom-attr.cs          \
112         double-cast.cs          \
113         newobj-valuetype.cs     \
114         arraylist-clone.cs      \
115         setenv.cs               \
116         vtype.cs                \
117         isvaluetype.cs          \
118         iface6.cs               \
119         iface7.cs               \
120         ipaddress.cs            \
121         array-vt.cs             \
122         interface1.cs           \
123         reflection-enum.cs      \
124         reflection-prop.cs      \
125         reflection4.cs          \
126         reflection5.cs          \
127         reflection-const-field.cs \
128         many-locals.cs          \
129         string-compare.cs       \
130         test-prime.cs           \
131         params.cs               \
132         reflection.cs           \
133         interface.cs            \
134         iface.cs                \
135         iface2.cs               \
136         iface3.cs               \
137         iface4.cs               \
138         iface-large.cs          \
139         virtual-method.cs       \
140         intptrcast.cs           \
141         indexer.cs              \
142         stream.cs               \
143         console.cs              \
144         shift.cs                \
145         jit-int.cs              \
146         jit-uint.cs             \
147         jit-long.cs             \
148         long.cs                 \
149         jit-ulong.cs            \
150         jit-float.cs            \
151         pop.cs                  \
152         time.cs                 \
153         appdomain.cs        \
154         appdomain1.cs           \
155         appdomain2.cs           \
156         appdomain-client.cs     \
157         appdomain-unload.cs \
158         appdomain-async-invoke.cs       \
159         loader.cs       \
160         pointer.cs              \
161         hashcode.cs             \
162         delegate1.cs            \
163         delegate2.cs            \
164         delegate3.cs            \
165         delegate5.cs            \
166         delegate6.cs            \
167         delegate7.cs            \
168         delegate8.cs            \
169         delegate9.cs            \
170         remoting1.cs            \
171         remoting2.cs            \
172         remoting3.cs            \
173         remoting4.cs            \
174         remoting5.cs            \
175         largeexp.cs             \
176         largeexp2.cs            \
177         marshalbyref1.cs        \
178         static-ctor.cs          \
179         inctest.cs              \
180         bound.cs                \
181         array-invoke.cs         \
182         test-arr.cs             \
183         decimal.cs              \
184         decimal-array.cs        \
185         marshal.cs              \
186         marshal1.cs             \
187         marshal2.cs             \
188         marshal3.cs             \
189         marshal5.cs             \
190         marshal6.cs             \
191         marshal7.cs             \
192         marshal8.cs             \
193         marshal9.cs             \
194         marshalbool.cs          \
195         marshal-valuetypes.cs   \
196         test-byval-in-struct.cs \
197         thread.cs               \
198         thread5.cs              \
199         thread6.cs              \
200         thread-static.cs        \
201         thread-static-init.cs   \
202         context-static.cs       \
203         float-pop.cs            \
204         interfacecast.cs        \
205         array3.cs               \
206         classinit.cs            \
207         classinit2.cs           \
208         synchronized.cs         \
209         async_read.cs           \
210         threadpool.cs           \
211         threadpool1.cs          \
212         threadpool-exceptions1.cs \
213         threadpool-exceptions2.cs \
214         threadpool-exceptions3.cs \
215         threadpool-exceptions4.cs \
216         threadpool-exceptions5.cs \
217         threadpool-exceptions6.cs \
218         threadpool-exceptions7.cs \
219         base-definition.cs      \
220         bug-27420.cs            \
221         bug-47295.cs            \
222         bug-46781.cs            \
223         bug-48015.cs            \
224         bug-42136.cs            \
225         bug-59286.cs            \
226         bug-70561.cs            \
227         bug-78311.cs            \
228         bug-78653.cs            \
229         bug-78656.cs            \
230         bug-77127.cs            \
231         bug-323114.cs           \
232         interlocked.cs          \
233         cross-domain.cs         \
234         appdomain-exit.cs       \
235         delegate-async-exit.cs  \
236         delegate-delegate-exit.cs       \
237         delegate-exit.cs        \
238         finalizer-abort.cs      \
239         finalizer-exception.cs  \
240         finalizer-exit.cs       \
241         finalizer-thread.cs     \
242         main-exit.cs    \
243         main-returns-abort-resetabort.cs        \
244         main-returns-background-abort-resetabort.cs     \
245         main-returns-background-resetabort.cs   \
246         main-returns-background.cs      \
247         main-returns-background-change.cs       \
248         main-returns.cs         \
249         subthread-exit.cs       \
250         desweak.cs              \
251         cominterop.cs           \
252         exists.cs               \
253         handleref.cs    \
254         transparentproxy.cs \
255         dbnull-missing.cs       \
256         test-type-ctor.cs       \
257         soft-float-tests.cs     \
258         thread-exit.cs          \
259         finalize-parent.cs      \
260         assemblyresolve_event2.2.cs     \
261         interlocked-2.2.cs      \
262         pinvoke-2.2.cs          \
263         bug-78431.2.cs          \
264         bug-79684.2.cs          \
265         catch-generics.2.cs     \
266         event-get.2.cs          \
267         safehandle.2.cs         \
268         stackframes-async.2.cs          \
269         module-cctor-loader.2.cs        \
270         generics-invoke-byref.2.cs      \
271         generic-signature-compare.2.cs  \
272         generics-sharing.2.cs   \
273         shared-generic-methods.2.cs     \
274         shared-generic-synchronized.2.cs        \
275         generic-inlining.2.cs   \
276         generic-initobj.2.cs    \
277         generic-delegate.2.cs   \
278         generic-sizeof.2.cs     \
279         generic-virtual.2.cs    \
280         generic-interface-methods.2.cs  \
281         generic-array-type.2.cs \
282         generic-method-patching.2.cs    \
283         generic-static-methods.2.cs     \
284         generic-null-call.2.cs  \
285         generic-special.2.cs    \
286         generic-exceptions.2.cs \
287         generic-virtual2.2.cs   \
288         generic-valuetype-interface.2.cs        \
289         generic-getgenericarguments.2.cs        \
290         generic-type-builder.2.cs       \
291         generic-synchronized.2.cs       \
292         generic-delegate-ctor.2.cs      \
293         generic-array-iface-set.2.cs    \
294         generic-typedef.2.cs    \
295         generic-marshalbyref.2.cs       \
296         generic-xdomain.2.cs    \
297         bug-431413.2.cs \
298         bug-459285.2.cs \
299         generic-virtual-invoke.2.cs     \
300         bug-461198.2.cs \
301         generic-sealed-virtual.2.cs     \
302         generic-system-arrays.2.cs      \
303         generic-stack-traces.2.cs       \
304         generic-stack-traces2.2.cs      \
305         bug-472600.2.cs \
306         recursive-generics.2.cs \
307         bug-473482.2.cs \
308         bug-473999.2.cs \
309         bug-479763.2.cs \
310         bug-616463.cs   \
311         bug-80392.2.cs          \
312         dynamic-method-access.2.cs      \
313         dynamic-method-finalize.2.cs    \
314         bug-82194.2.cs  \
315         anonarray.2.cs  \
316         ienumerator-interfaces.2.cs     \
317         array-enumerator-ifaces.2.cs    \
318         generic_type_definition_encoding.2.cs \
319         generic_type_definition.2.cs    \
320         bug-333798.2.cs         \
321         bug-333798-tb.2.cs              \
322         bug-335131.2.cs         \
323         bug-322722_patch_bx.2.cs                \
324         bug-348522.2.cs         \
325         bug-340662_bug.cs       \
326         bug-322722_dyn_method_throw.2.cs        \
327         bug-389886-2.cs \
328         bug-325283.2.cs \
329         thunks.cs \
330         winx64structs.cs \
331         bug-349190.2.cs \
332         nullable_boxing.2.cs    \
333         valuetype-equals.cs     \
334         custom-modifiers.2.cs   \
335         bug-382986.cs   \
336         test-inline-call-stack.cs       \
337         bug-324535.cs   \
338         modules.cs      \
339         bug-81673.cs    \
340         bug-81691.cs    \
341         bug-80307.cs    \
342         bug-415577.cs   \
343         filter-stack.cs \
344         vararg2.cs      \
345         bug-389886-sre-generic-interface-instances.cs   \
346         bug-461867.cs   \
347         bug-461941.cs   \
348         bug-461261.cs   \
349         bug-400716.cs   \
350         bug-462592.cs   \
351         bug-459094.cs   \
352         generic-unloading.2.cs  \
353         generic-unloading-sub.2.cs      \
354         bug-467456.cs   \
355         appdomain-unload-callback.cs    \
356         bug-508538.cs   \
357         bug-472692.2.cs         \
358         gchandles.cs    \
359         interlocked-3.cs        \
360         interlocked-4.2.cs      \
361         finalizer-wait.cs       \
362         critical-finalizers.cs  \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs     \
386         async-with-cb-throws.cs
387
388 TEST_CS_SRC_DIST=       \
389         $(BASE_TEST_CS_SRC)     \
390         async-exc-compilation.cs \
391         filter-stack.cs \
392         finally_guard.cs
393
394 TEST_CS_SRC_GEN = \
395         runtime-invoke.gen.cs \
396         imt_big_iface_test.cs
397
398 if AMD64
399 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
400 # #651684
401 PLATFORM_DISABLED_TESTS = finally_guard.exe
402 else
403 if X86
404 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
405 else
406 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
407 endif
408 endif
409
410 if IA64
411 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
412 # bug #319249
413 PLATFORM_DISABLED_TESTS=exception17.exe
414 PLATFORM_DISABLED_TESTS+=winx64structs.exe
415 endif
416
417 if X86
418
419 if HOST_WIN32
420 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
421 endif
422
423 endif
424
425 if POWERPC
426 # bug #71274
427 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
428 endif
429
430 if ARM
431 PLATFORM_DISABLED_TESTS=filter-stack.exe
432 endif
433
434 if MIPS
435 # monitor.exe is racy
436 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
437 endif
438
439 if S390x
440 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
441 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
442 endif
443
444 # The two finalizer tests only work under sgen
445 # gc-altstack.exe fails under boehm because it has no support for altstack
446 # bug-459094.exe creates an extremely deep directory tree
447 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
448 # reverted.
449 # generic_type_definition.2.exe depends on COMPILER_ACCESS which is no longer supported.
450 DISABLED_TESTS=                 \
451         delegate-async-exception.exe    \
452         bug-348522.2.exe        \
453         finalizer-wait.exe      \
454         critical-finalizers.exe \
455         gc-altstack.exe \
456         bug-459094.exe \
457         delegate-invoke.exe \
458         generic_type_definition.2.exe \
459         $(PLATFORM_DISABLED_TESTS)
460
461 DISABLED_TESTS_WRENCH=  \
462         $(DISABLED_TESTS)       \
463         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
464         main-returns-background-resetabort.exe \
465         main-returns-background-abort-resetabort.exe    \
466         main-returns-background.exe     \
467         thread6.exe     \
468         assemblyresolve_event3.exe \
469         delegate2.exe   \
470         finally_guard.exe       \
471         finalizer-abort.exe     \
472         finalizer-exit.exe      \
473         finalizer-thread.exe \
474         appdomain-async-invoke.exe
475
476 AOT_DISABLED_TESTS=constraints-load.exe
477
478 # These only compile with MS CSC
479 TEST_CSC_SRC=                   \
480         vararg.cs
481
482 TEST_IL_SRC=                    \
483         field-access.il         \
484         method-access.il        \
485         ldftn-access.il         \
486         cpblkTest.il            \
487         vbinterface.il          \
488         calliTest.il            \
489         ckfiniteTest.il         \
490         fault-handler.il                \
491         locallocTest.il         \
492         initblkTest.il          \
493         qt-instance.il          \
494         vararg.il               \
495         bug-29859.il            \
496         bug-78549.il            \
497         static-fields-nonconst.il       \
498         reload-at-bb-end.il     \
499         test-enum-indstoreil.il \
500         filter-bug.il           \
501         even-odd.il             \
502         bug-82022.il    \
503         vt-sync-method.il       \
504         enum_types.il   \
505         invalid-token.il        \
506         call_missing_method.il  \
507         call_missing_class.il   \
508         ldfld_missing_field.il  \
509         ldfld_missing_class.il  \
510         find-method.2.il        \
511         bug-79215.2.il  \
512         bug-79956.2.il  \
513         bug-327438.2.il \
514         bug-387274.2.il \
515         bug-426309.2.il \
516         ldtoken_with_byref_typespec.2.il \
517         resolve_method_bug.2.il \
518         resolve_field_bug.2.il \
519         resolve_type_bug.2.il   \
520         generics-sharing-other-exc.2.il \
521         generic-ldobj.2.il      \
522         generic-mkrefany.2.il   \
523         generic-refanyval.2.il  \
524         generic-ldtoken.2.il    \
525         generic-ldtoken-method.2.il     \
526         generic-ldtoken-field.2.il      \
527         generic-tailcall.2.il   \
528         generic-tailcall2.2.il  \
529         generic-array-exc.2.il  \
530         generic-valuetype-newobj2.2.il  \
531         generic-valuetype-newobj.2.il   \
532         generic-constrained.2.il        \
533         generic-type-load-exception.2.il        \
534         bug-81466.il    \
535         bug457574.il    \
536         bug445361.il    \
537         bug-463303.il   \
538         bug469742.2.il  \
539         bug-528055.il   \
540         constraints-load.il     \
541         array_load_exception.il \
542         bug-481403.il   \
543         interface-with-static-method.il \
544         bug-515884.il   \
545         bug-633291.il   \
546         delegate-with-null-target.il    \
547         bug-318677.il
548
549 # pre-requisite test sources: files that are not test themselves
550 # but that need to be compiled
551 PREREQ_IL_SRC=event-il.il module-cctor.il
552 PREREQ_CS_SRC=
553 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
554 PREREQ_CS_DLL_SRC=
555
556 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
557 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
558 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
559 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
560 TESTBS=$(BENCHSRC:.cs=.exe)
561 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
562
563 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
564         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
565
566 %.exe: %.il
567         $(ILASM) -out:$@ $<
568
569 %.exe: %.cs TestDriver.dll
570         $(MCS) -r:TestDriver.dll -out:$@ $<
571
572 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
573 if POWERPC
574 test_platform:
575 else
576 # Can't use mkbundle on win32 since there is no static build there
577 # Can't run test-unhandled-exception on Windows because of all the debug popups...
578 if HOST_WIN32
579 test_platform:
580 else
581 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
582 #test_platform: testbundle test-iomap-regression
583 test_platform:  test-iomap-regression
584 endif
585 endif
586
587 if X86
588 if HOST_WIN32
589 else
590 test_platform: test-eglib-remap
591 endif
592 endif
593
594 # Target to precompile the test executables
595 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
596
597 #
598 # Test that no symbols are missed in eglib-remap.h
599 #
600 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
601 test-eglib-remap:
602         @echo "Testing eglib remap..."
603         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
604
605 #
606 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
607 # code that checks that the table is properly sorted
608 #
609 test-messages: w32message.exe
610         > test_messages.zero
611         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
612
613 if MOONLIGHT
614 test_2_1 : test-coreclr-security
615 else
616 test_2_1 :
617 endif
618
619 if AMD64
620 test-sgen : sgen-tests
621 else
622 if X86
623 test-sgen : sgen-tests
624 else
625 if ARM
626 test-sgen : sgen-tests
627 else
628 if S390x
629 test-sgen : sgen-regular-tests
630 endif
631 endif
632 endif
633 endif
634
635 test: assemblyresolve/test/asm.dll testjit test-type-load test-generic-sharing test_platform test_2_1 test-messages
636 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
637
638 # Remove empty .stdout and .stderr files for wrench
639 rm-empty-logs:
640         @echo "Removing empty logs..."
641         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
642
643 assemblyresolve/test/asm.dll:
644         $(MAKE) -C assemblyresolve prereq
645
646 TestDriver.dll:
647         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
648
649 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
650         @failed=0; \
651         passed=0; \
652         for i in $(TESTSI_CS); do       \
653                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
654                 then \
655                         passed=`expr $${passed} + 1`; \
656                 else \
657                         if [ $$? = 2 ]; then break; fi; \
658                         failed=`expr $${failed} + 1`; \
659                 fi \
660         done; \
661         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
662
663 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
664         @failed=0; \
665         passed=0; \
666         for i in $(TESTSI_IL); do       \
667                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" $(RUNTIME_ARGS); \
668                 then \
669                         passed=`expr $${passed} + 1`; \
670                 else \
671                         if [ $$? = 2 ]; then break; fi; \
672                         failed=`expr $${failed} + 1`; \
673                 fi \
674         done; \
675         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
676
677 testb: $(TEST_PROG) $(TESTBS)
678         for i in $(TESTBS); do  \
679                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS);     \
680         done
681
682 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
683         @failed=0; \
684         passed=0; \
685         failed_tests="";\
686         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
687                 rm -f $${i}.so; \
688                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
689                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' $(RUNTIME_ARGS); \
690                 then \
691                         passed=`expr $${passed} + 1`; \
692                 else \
693                         if [ $$? = 2 ]; then break; fi; \
694                         failed=`expr $${failed} + 1`; \
695                         failed_tests="$${failed_tests} $$i"; \
696                 fi \
697         done; \
698         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
699         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
700           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
701
702 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
703         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
704
705 testjit-wrench:
706         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
707
708 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
709         @failed=0; \
710         passed=0; \
711         failed_tests="";\
712         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
713                 rm -f $${i}.so; \
714                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
715                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' $(RUNTIME_ARGS); \
716                 then \
717                         passed=`expr $${passed} + 1`; \
718                 else \
719                         if [ $$? = 2 ]; then break; fi; \
720                         failed=`expr $${failed} + 1`; \
721                         failed_tests="$${failed_tests} $$i"; \
722                 fi \
723         done; \
724         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
725         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
726           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
727
728 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
729         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
730
731 testjit:
732         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
733
734 testaot:
735         @$(MAKE) AOT=1 runtest
736
737 testtrace:
738         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
739
740 testinterp:
741         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
742
743 testjitspeed: $(JITTEST_PROG) $(TESTBS)
744         for i in $(TESTBS); do  \
745                 echo $$i;       \
746                 time $(JITTEST_PROG) $$i;       \
747         done
748
749 test-iomap-regression: exists.cs
750         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
751         @echo "Testing exists.exe..."
752         @MONO_IOMAP=all $(RUNTIME) exists.exe
753
754 stresstest: $(STRESS_TESTS)
755         @failed=0; \
756         passed=0; \
757         failed_tests="";\
758         for i in $(STRESS_TESTS); do    \
759                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
760                 then \
761                         passed=`expr $${passed} + 1`; \
762                 else \
763                         if [ $$? = 2 ]; then break; fi; \
764                         failed=`expr $${failed} + 1`; \
765                         failed_tests="$${failed_tests} $$i"; \
766                 fi \
767         done; \
768         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
769         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
770           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
771
772 testbundle: console.exe
773         @echo "Testing mkbundle..."
774         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
775         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
776         @- rm -rf a.out
777
778 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
779 test-type-load: TestDriver.dll
780         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
781         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
782         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
783         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
784         @echo "Testing load-exception.exe..."
785         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
786
787
788 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs
789
790 SGEN_TESTS =    \
791         sgen-descriptors.exe    \
792         sgen-gshared-vtype.exe
793
794 sgen-regular-tests: $(SGEN_TESTS)
795         @for fn in $+ ; do      \
796                 echo "Testing $$fn ...";        \
797                 MONO_GC_PARAMS=major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1; \
798                 MONO_ENV_OPTIONS="--gc=sgen"                                    $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1; \
799                 MONO_GC_PARAMS=major=marksweep-par,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;     \
800                 MONO_GC_PARAMS=minor=split MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;     \
801                 MONO_GC_PARAMS=major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;    \
802                 MONO_GC_PARAMS=minor=split,major=marksweep,concurrent-sweep MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;        \
803                 MONO_GC_PARAMS=major=marksweep-par,minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;      \
804                 MONO_GC_PARAMS=minor=split,alloc-ratio=95 MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout 2> $$fn.stderr || exit 1;      \
805         done
806
807
808 sgen-tests: sgen-regular-tests sgen-bridge.exe sgen-bridge-major-fragmentation.exe
809         @echo "Testing sgen-bridge.exe ...";    \
810         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr || exit 1;      \
811         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge.exe > sgen-bridge.exe.stdout 2> sgen-bridge.exe.stderr || exit 1;  \
812         echo "Testing sgen-bridge-major-fragmentation.exe ..."; \
813         MONO_GC_PARAMS=bridge=Bridge MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr || exit 1;  \
814         MONO_GC_PARAMS=bridge=Bridge,minor=split MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) sgen-bridge-major-fragmentation.exe > sgen-bridge-major-fragmentation.exe.stdout 2> sgen-bridge-major-fragmentation.exe.stderr || exit 1;
815
816
817 # Generated tests for runtime invoke
818 EXTRA_DIST += gen-runtime-invoke.cs
819 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
820         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
821         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
822
823 EXTRA_DIST += make-imt-test.cs
824 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
825         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
826         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
827
828 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
829 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
830         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
831 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
832         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
833
834 EXTRA_DIST += unhandled-exception-base-configuration.config
835 EXTRA_DIST += unhandled-exception-legacy-configuration.config
836 EXTRA_DIST += appdomain-unload.exe.config
837 EXTRA_DIST += unhandled-exception-test-case.2.cs
838 EXTRA_DIST += unhandled-exception-test-runner.2.cs
839 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
840         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
841 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
842         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
843 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
844         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
845 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
846         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
847         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
848         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
849         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
850 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
851         $(MCS) /debug unhandled-exception-test-case.1.cs
852 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
853         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
854 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
855         $(MCS) /debug unhandled-exception-test-case.2.cs
856 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
857         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
858 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
859         $(MCS) /debug unhandled-exception-test-runner.2.cs
860
861 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
862         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
863
864 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
865 bug-80307.exe: $(srcdir)/bug-80307.cs
866         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
867         cd $(top_builddir)/runtime && $(MAKE) test-support-files
868
869 EXTRA_DIST += bug-81673-interface.cs
870 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
871         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
872         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
873         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
874
875 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
876 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
877         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
878         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
879         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
880         rm -f bug-81691-a.dll
881 bug-81691.exe: bug-81691-b.dll
882
883 EXTRA_DIST += bug-81466-lib.il
884 bug-81466-lib.dll: bug-81466-lib.il
885         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
886 bug-81466.exe: bug-81466.il bug-81466-lib.dll
887         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
888
889 EXTRA_DIST += bug-324535-il.il
890 bug-324535-il.dll : bug-324535-il.il
891         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
892 bug-324535.exe : bug-324535.cs bug-324535-il.dll
893         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
894
895 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
896 custom-modifiers-lib.dll: custom-modifiers-lib.il
897         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
898 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
899         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
900
901 EXTRA_DIST += bug-382986-lib.cs
902 bug-382986-lib.dll: bug-382986-lib.cs
903         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
904 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
905         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
906
907 EXTRA_DIST += coreclr-security.cs
908
909 if MOONLIGHT
910 coreclr-security.exe : coreclr-security.cs
911         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
912
913 test-coreclr-security : coreclr-security.exe
914         @echo "Testing coreclr-security.exe..."
915         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
916 endif
917
918 EXTRA_DIST += generic-unboxing.2.il
919 generic-unboxing.2.dll : generic-unboxing.2.il
920         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
921
922 EXTRA_DIST += generic-boxing.2.il
923 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
924         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
925
926 EXTRA_DIST += generic-unbox.2.cs
927 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
928         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
929
930 EXTRA_DIST += generic-box.2.cs
931 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
932         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
933
934 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
935 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
936         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
937 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
938         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
939
940 bug-3903.exe: bug-3903.cs
941         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
942
943 gshared: test-generic-sharing
944
945 gshared-aot:
946         @$(MAKE) AOT=1 gshared
947
948 GSHARED_TESTS = \
949                 generics-sharing.2.exe shared-generic-methods.2.exe     \
950                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
951                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
952                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
953                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
954                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
955                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
956                 generic-virtual.2.exe generic-tailcall.2.exe                    \
957                 generic-interface-methods.2.exe generic-array-type.2.exe        \
958                 generic-method-patching.2.exe generic-static-methods.2.exe      \
959                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
960                 generic-array-exc.2.exe generic-special.2.exe                   \
961                 generic-exceptions.2.exe generic-delegate2.2.exe                \
962                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
963                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
964                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
965                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
966                 generic-constrained.2.exe bug-431413.2.exe                      \
967                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
968                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
969                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
970                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
971                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
972                 bug-479763.2.exe generic-xdomain.2.exe                          \
973                 generic-type-load-exception.2.exe bug-616463.exe        \
974                 bug-1147.exe
975
976 test-generic-sharing-normal: $(GSHARED_TESTS)
977         @for fn in $+ ; do      \
978                 echo "Testing $$fn ...";        \
979                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
980                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
981                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
982                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
983                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
984         done
985
986 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
987         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
988
989 test-generic-sharing:
990         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
991
992 EXTRA_DIST += async-exceptions.cs
993 async-exceptions.exe : async-exceptions.cs
994         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
995 test-async-exceptions : async-exceptions.exe
996         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
997         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
998
999 EXTRA_DIST += modules.cs modules-m1.cs
1000 modules-m1.netmodule: modules-m1.cs
1001         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1002 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1003         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1004
1005 # Useful if mono is compiled with --enable-shared=no
1006 patch-libtool:
1007         cp "../../libtool" .
1008         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1009         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1010         touch libtest.c
1011
1012 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
1013 test-process-exit:
1014         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1015         @echo "Testing bug-438454.exe..."
1016         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1017         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1018
1019 OOM_TESTS =     \
1020         gc-oom-handling.exe     \
1021         gc-oom-handling2.exe
1022
1023
1024 test-oom: $(OOM_TESTS)
1025         @for fn in $+ ; do      \
1026                 echo "Testing $$fn ...";        \
1027                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1028                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1029                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1030         done
1031
1032
1033 noinst_LTLIBRARIES = libtest.la
1034
1035 INCLUDES = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1036
1037 if HOST_WIN32
1038 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1039 # This shows up when compiling mono_test_marshal_delegate ()
1040 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1041 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1042 # can't find them. So we use --kill-at to remove the @ suffix as well.
1043 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1044 else
1045 libtest_la_LDFLAGS = -rpath `pwd`
1046 endif
1047 libtest_la_SOURCES = libtest.c
1048 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1049
1050 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat